#include <stdio.h>
#include <string.h>
#include "rectangle.h"
#include "graphics.h"

int menu() {
    Rectangle rects[MAX_RECTANGLES];
    int numRects = 0;
    char command[20];
    int x, y, l, h, p;

    do {
        printf("\nType a command (create x,y+l,h | moveleft x,y+p | moveright x,y+p | done): ");
        scanf("%s", command);
        
        if (strcmp(command, "create") == 0) {
            scanf("%d,%d+%d,%d", &x, &y, &l, &h);
            if (l <= 0 || h <= 0 || x <= 0 || y <= 0) {
                printf("Error: Invalid dimensions or coordinates. Width, height, x, and y must be greater than zero.\n");
                continue;
            }
            createRectangle(rects, &numRects, x, y, l, h);
            applyGravity(rects, numRects);
            printRectangle(rects, numRects);
        }
        else if (strcmp(command, "moveleft") == 0) {
            scanf("%d,%d+%d", &x, &y, &p);
            moveSide(rects, numRects, x, y, -p);
            applyGravity(rects, numRects);
            printRectangle(rects, numRects);
        } 
        else if (strcmp(command, "moveright") == 0) {
            scanf("%d,%d+%d", &x, &y, &p);
            moveSide(rects, numRects, x, y, p);
            applyGravity(rects, numRects);
            printRectangle(rects, numRects);
        }
    } while (strcmp(command, "done") != 0);

    printf("\n******* Thanks! *******\n\n\n");
    return 0;
}

int main() {
    menu();
    return 0;
}