#include <stdlib.h>
#include "list.h"

Node* createNode(int x, int y, int l, int h) {
    Node* newNode = (Node*)malloc(sizeof(Node));
    if (newNode) {
        newNode->rect.x = x;
        newNode->rect.y = y;
        newNode->rect.l = l;
        newNode->rect.h = h;
        newNode->next = NULL;
        newNode->prev = NULL;
    }
    return newNode;
}

void addNode(Node** head, int x, int y, int l, int h) {
    Node* newNode = createNode(x, y, l, h);
    if (*head == NULL) {
        *head = newNode;
    } else {
        Node* temp = *head;
        while (temp->next != NULL) {
            temp = temp->next;
        }
        temp->next = newNode;
        newNode->prev = temp;
    }
}

void removeNode(Node** head, Node* node) {
    if (*head == NULL || node == NULL) {
        return;
    }
    if (*head == node) {
        *head = node->next;
    }
    if (node->next != NULL) {
        node->next->prev = node->prev;
    }
    if (node->prev != NULL) {
        node->prev->next = node->next;
    }
    free(node);
}

int isAreaOccupied(Node* head, int x, int y, int l, int h) {
    Node* temp = head;
    int newRectRight = x + l;
    int newRectTop = y + h;

    if (newRectRight > TABLE_WIDTH || newRectTop > TABLE_HEIGHT || x < 1 || y < 1) {
        return 1;
    }

    while (temp != NULL) {
        Rectangle* rect = &temp->rect;
        int rectRight = rect->x + rect->l;
        int rectTop = rect->y + rect->h;

        if (rect->x < newRectRight && rectRight > x && rect->y < newRectTop && rectTop > y) {
            return 1;
        }
        temp = temp->next;
    }
    return 0;
}
