#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rectangle.h"
#include "list.h"
#include "menu.h"

int menu() {
    Node* rects = NULL;
    char command[20];
    int x, y, l, h, p;
    int x1, y1, x2, y2;

    do {
        printf("\nType a command (create x,y+l,h | moveleft x,y+p | moveright x,y+p | merge x1,y1+x2,y2 | done): ");
        scanf("%s", command);

        // Verifica se o comando tem o formato esperado
        if (strncmp(command, "create", 6) != 0 &&
            strncmp(command, "moveleft", 8) != 0 &&
            strncmp(command, "moveright", 9) != 0 &&
            strncmp(command, "merge", 5) != 0 &&
            strncmp(command, "done", 4) != 0) {
            printf("Error: Invalid command format. Please use one of the specified formats.\n");
            continue;
        }

        if (strcmp(command, "create") == 0) {
            if (scanf("%d,%d+%d,%d", &x, &y, &l, &h) != 4 || l <= 0 || h <= 0 || x <= 0 || y <= 0) {
                printf("Error: Invalid dimensions or coordinates. Width, height, x, and y must be greater than zero.\n");
                continue;
            }
            createRectangle(&rects, x, y, l, h);
            applyGravity(rects);
            printRectangle(rects);
            alertaSobreposicao(rects); // Verifica se há sobreposições após a criação
        } else if (strcmp(command, "moveleft") == 0) {
            if (scanf("%d,%d+%d", &x, &y, &p) != 3) {
                printf("Error: Invalid moveleft command format.\n");
                continue;
            }
            moveSide(rects, x, y, -p);
            applyGravity(rects);
            printRectangle(rects);
            alertaSobreposicao(rects); // Verifica se há sobreposições após mover o retângulo
        } else if (strcmp(command, "moveright") == 0) {
            if (scanf("%d,%d+%d", &x, &y, &p) != 3) {
                printf("Error: Invalid moveright command format.\n");
                continue;
            }
            moveSide(rects, x, y, p);
            applyGravity(rects);
            printRectangle(rects);
            alertaSobreposicao(rects); // Verifica se há sobreposições após mover o retângulo
        } else if (strcmp(command, "merge") == 0) {
            if (scanf("%d,%d+%d,%d", &x1, &y1, &x2, &y2) != 4) {
                printf("Error: Invalid merge command format.\n");
                continue;
            }
            mergeCommand(&rects, x1, y1, x2, y2);
            applyGravity(rects);
            printRectangle(rects);
            alertaSobreposicao(rects); // Verifica se há sobreposições após a fusão
        }
    } while (strcmp(command, "done") != 0);

    printf("\n******* Thanks! *******\n\n\n");
    return 0;
}
