#include <stdio.h>
#include <assert.h>
#include "rectangle.h"
#include "list.h"
#include "menu.h"

// Teste de Unidade
void test_createRectangle() {
    Node* head = NULL;
    createRectangle(&head, 1, 1, 5, 5);
    assert(head != NULL);
    assert(head->rect.x == 1);
    assert(head->rect.y == 1);
    assert(head->rect.l == 5);
    assert(head->rect.h == 5);
    printf("test_createRectangle passed.\n");

    // Cleanup
    removeNode(&head, head);
}

// Teste de Integração
void test_integration() {
    Node* head = NULL;
    
    // Cria dois retângulos
    createRectangle(&head, 1, 1, 5, 5);
    createRectangle(&head, 10, 10, 5, 5);
    
    // Verifica se os dois retângulos foram criados corretamente
    assert(head != NULL);
    assert(head->next != NULL);
    assert(head->rect.x == 1 && head->rect.y == 1 && head->rect.l == 5 && head->rect.h == 5);
    assert(head->next->rect.x == 10 && head->next->rect.y == 10 && head->next->rect.l == 5 && head->next->rect.h == 5);
    
    // Move o primeiro retângulo
    moveSide(head, 1, 1, 2);
    assert(head->rect.x == 3 && head->rect.y == 1);
    
    // Aplica gravidade
    applyGravity(head);
    assert(head->rect.y == 1);
    
    // Tenta fundir os retângulos (deve falhar)
    mergeCommand(&head, 3, 1, 10, 10);
    assert(head->next != NULL); // Os retângulos ainda existem separadamente
    
    printf("test_integration passed.\n");
    
    // Cleanup
    removeNode(&head, head->next);
    removeNode(&head, head);
}

int main() {
    test_createRectangle();
    test_integration();
    printf("All tests passed.\n");
    return 0;
}
